macro(run_conan)
  if(NOT EXISTS "${CMAKE_CURRENT_BINARY_DIR}/conan.cmake")
    message(
      STATUS
        "Downloading conan.cmake from https://github.com/conan-io/cmake-conan")
    file(
      DOWNLOAD
      "https://raw.githubusercontent.com/conan-io/cmake-conan/0.18.0/conan.cmake"
      "${CMAKE_CURRENT_BINARY_DIR}/conan.cmake"
      EXPECTED_HASH
        SHA256=65fc3508c91bf201f5472d28b21259e02b6f975a2917be457412ab7a87906c1e
      TLS_VERIFY ON)
  endif()

  include(${CMAKE_CURRENT_BINARY_DIR}/conan.cmake)

  conan_cmake_configure(
    REQUIRES
    ${CONAN_EXTRA_REQUIRES}
    ms-gsl/3.1.0
    GENERATORS
    cmake_find_package
    cmake_paths)

  conan_cmake_autodetect(settings)

  conan_cmake_install(
    PATH_OR_REFERENCE
    .
    BUILD
    missing
    REMOTE
    conancenter
    SETTINGS
    ${settings})

  include(${CMAKE_CURRENT_BINARY_DIR}/conan_paths.cmake)
endmacro()
