#pragma once

#include <stdexcept>

namespace pi_database::dynamic_model
{

enum class ErrorType {
  DivisionByZero,
  DomainError,
  DomainErrorAtanh,
  DomainErrorLog,
  DomainErrorSqrt,
  DomainErrorAsin,
  DomainErrorAcos,
  DomainErrorAcosh,
  Other
};

class InvalidFunctionCallException : public std::runtime_error
{
public:
  explicit InvalidFunctionCallException(int errorCode);

  [[nodiscard]] auto get_error_type() const -> ErrorType;

private:
  int errorCode;
};

}// namespace pi_database::dynamic_model
