#include "constraints.hpp"

#include "utility.hpp"

namespace pi_database::dynamic_model
{

namespace
{

constexpr auto getOffset()
{
  constexpr auto numberOfInitialValues = getNumberOfOdes();
  return getNumberOfOdes() + numberOfInitialValues + getDimensionOfFittingFunction();
}

}// namespace

auto constraints(
  const double time,
  const std::span<const double> states,
  const double concentration,
  const std::span<const double> modelParameters) -> std::array<double, getTotalNumberOfConstraints()>
{
  return call_xfun<getTotalNumberOfConstraints(), getOffset()>(time, states, concentration, modelParameters);
}

auto constraints(
  const double time,
  const std::span<const double> states,
  const std::span<const double> modelParameters) -> std::array<double, getTotalNumberOfConstraints()>
{
  return call_xfun<getTotalNumberOfConstraints(), getOffset()>(time, states, modelParameters);
}

}// namespace pi_database::dynamic_model
