
function xfun_wrapper(x, n, f, m, active) result(ierr) bind(c)
   use, intrinsic::iso_c_binding
   implicit none
   
   interface
   ! Marek (05.04.2024): Mirror the interface of xfun in the autogenerated
   ! Fortran code from PCOMP to stop compilation if xfun is called incorrectly.
   ! The size of active is manually set to one byte after the conversion of
   ! the PCOMP code to ensure that the size matches the size of the C-bool.
   ! The default size for logicals in Fortran is 4 Byte.
      subroutine xfun (x,n,f,m,active,ierr)
         integer n, m
         double precision x(n), f(m)
         logical*1 active(m)
         integer ierr
      end subroutine xfun
   end interface

   integer(c_int), value, intent(in) :: n, m
   real(c_double), intent(in) :: x(n)
   real(c_double), intent(out) :: f(m)
   logical(c_bool), intent(in) :: active(m)
   integer(c_int) :: ierr

   ierr = 0

   call xfun(x, n, f, m, active, ierr)

end function xfun_wrapper
