#include "fittingFunction.hpp"

#include "utility.hpp"

namespace pi_database::dynamic_model
{

namespace
{

constexpr auto getOffset()
{
  constexpr auto numberOfInitialValues = getNumberOfOdes();
  return getNumberOfOdes() + numberOfInitialValues;
}

}// namespace

auto fittingFunction(
  const double time,
  const std::span<const double> states,
  const double concentration,
  const std::span<const double> modelParameters) -> std::array<double, getDimensionOfFittingFunction()>
{
  return call_xfun<getDimensionOfFittingFunction(), getOffset()>(time, states, concentration, modelParameters);
}

auto fittingFunction(
  const double time,
  const std::span<const double> states,
  const std::span<const double> modelParameters) -> std::array<double, getDimensionOfFittingFunction()>
{
  return call_xfun<getDimensionOfFittingFunction(), getOffset()>(time, states, modelParameters);
}

}// namespace pi_database::dynamic_model
