#include "getInitialValues.hpp"

#include "utility.hpp"

namespace pi_database::dynamic_model
{

namespace
{

constexpr auto getOffset()
{
  return getNumberOfOdes();
}

}// namespace

auto getInitialValues(
  const double time,
  const std::span<const double> states,
  const double concentration,
  const std::span<const double> modelParameters) -> std::array<double, getNumberOfOdes()>
{
  return call_xfun<getNumberOfOdes(), getOffset()>(time, states, concentration, modelParameters);
}

auto getInitialValues(
  const double time,
  const std::span<const double> states,
  const std::span<const double> modelParameters) -> std::array<double, getNumberOfOdes()>
{
  return call_xfun<getNumberOfOdes(), getOffset()>(time, states, modelParameters);
}

}// namespace pi_database::dynamic_model
