#pragma once

#include <vector>

namespace test_model
{

constexpr std::size_t getNumberOfOdes()
{
  return 6;
}

constexpr std::size_t getNumberOfModelParameters()
{
  return 3;
}

std::vector<double> ode(
  double /*time*/,
  const std::vector<double>& states,
  const std::vector<double>& /*modelParameters*/);

std::vector<double> getInitialValues(
  double /*time*/,
  const std::vector<double>& /*states*/,
  const std::vector<double>& modelParameters);

std::vector<double> fittingFunction(
  double /*time*/,
  const std::vector<double>& states,
  const std::vector<double>& /*modelParameters*/);

std::vector<double> constraints(
  double /*time*/,
  const std::vector<double>& states,
  const std::vector<double>& /*modelParameters*/);

}// namespace test_model
