#include <gtest/gtest.h>
#include <gmock/gmock.h>

#include "HOLDUP.hpp"

#include <PI-Problem-Database/dynamic_model.hpp>

#include <testUtility.hpp>

TEST(TestCasesHOLDUP, TestInvalidFunctionCallExceptionThrown)
{
  const auto time = 1.0;
  const std::vector<double> states{ 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 };
  const std::vector<double> modelParameters{ 1.0, 1.0, 1.0 };

  using ::testing::Pointwise;
  using ::testing::DoubleNear;

  EXPECT_THROW(
    try {
      pi_database::dynamic_model::ode(time, states, modelParameters);
    } catch (const pi_database::dynamic_model::InvalidFunctionCallException& e) {
      EXPECT_EQ(e.get_error_type(), pi_database::dynamic_model::ErrorType::DivisionByZero);
      throw;
    },
    pi_database::dynamic_model::InvalidFunctionCallException);
}
